/*
 * Copyright (c) 1993, by Cray Research Superservers, Inc.
 */

#ifndef	_SYS_SGAIO_H
#define	_SYS_SGAIO_H

#pragma ident	"@(#)sgaio.h 1.5	96/07/10 CRS"

#ifdef	__cplusplus
extern "C" {
#endif

/*
 * Ioctl commands
 */
#define	SGAIOC		('G' << 8)
#define	SGAIOCGET	(SGAIOC|0)	/* get device status */
#define	SGAIOCEXC	(SGAIOC|1)	/* exchange medium */
#define	SGAIOCMM	(SGAIOC|2)	/* Move Medium */
#define	SGAIOCPTE	(SGAIOC|3)	/* position transport element */
#define	SGAIOCRES	(SGAIOC|4)	/* read element status */
#define	SGAIOCIES	(SGAIOC|5)	/* initialize element status */
#define	SGAIOCREA	(SGAIOC|6)	/* retrieve element addr assignment */
#define	SGAIOCGEA	(SGAIOC|7)	/* get element addr from volume tag */
#define	SGAIOCLCK	(SGAIOC|8)	/* lock the door */
#define	SGAIOCRSV	(SGAIOC|9)	/* reserve element */
#define	SGAIOCRLS	(SGAIOC|10)	/* release element */

/*
 * Structures and definitions for media changer io control commands
 */

typedef struct sgaexc {			/* SGAIOEXC - exchange medium command */
	short		sga_telt_addr;	/* Transport element address */
	short		sga_src_addr;	/* Source element address */
	short		sga_dst_addr;	/* Destination element address */
	short		sga_dst_addr2;	/* Destination element address */
} sgaexc_t;

typedef struct sgamm {			/* SGAIOCMM - move medium command */
	short		sga_telt_addr;	/* Transport element address */
	short		sga_src_addr;	/* Source element address */
	short		sga_dst_addr;	/* Destination element address */
} sgamm_t;

typedef struct sgapte {			/* SGAIOCPTE - position to element */
	short		sga_telt_addr;	/* Transport element address */
	short		sga_delt_addr;	/* Destination element address */
} sgapte_t;

#define	SGA_RES_ALL	0x0		/* not supported yet */
#define	SGA_RES_MTE	0x1		/* media transport element */
#define	SGA_RES_MSE	0x2		/* media storage element */
#define	SGA_RES_IEE	0x3		/* import/export element */
#define	SGA_RES_DTE	0x4		/* data transport element */

typedef struct sga_rr_rply {		/* SGAIOCRES / SGAIOCGEA */
	u_char			:4,	/* reserved */
	sga_status_access	:1,	/* 1=element is accessible */
	sga_status_except	:1,	/* 1=cart in abnormal state */
				:1,	/* reserved */
	sga_status_full		:1;	/* 1=elt contains a cartridge */
	short		sga_elt_addr;	/* element address */
	short		sga_elt_type;	/* element type */
	u_char		sga_vol_tag[9];	/* volume tag */
	short		sga_ssea;	/* source storage element address */
	short		sga_stid;	/* scsi id */
	short		sga_slun;	/* scsi lun */
} sga_rr_rply_t;

typedef struct sgarr {			/* SGAIOCRES / SGAIOCGEA */
	short		sga_selt_addr;	/* start element address */
	short		sga_vol_tags;	/* 1 = want vol elt tags */
	short		sga_elt_type;	/* element type */
	short		sga_nelt;	/* number of elements allocated */
	short		sga_nresp;	/* number of resp elts found */
	u_char		sga_vol_tag[9];	/* volume tag */
	sga_rr_rply_t	*sga_res_vec;	/* results pointer */
} sgarr_t;

typedef struct sgarea {		/* SGAIOCREA - retrieve storage element info */
	short	sga_trans_elt_addr;	/* transport element base address */
	short	sga_trans_elt_num;	/* transport element number */
	short	sga_stor_elt_addr;	/* storage element base address */
	short	sga_stor_elt_num;	/* storage element number */
	short	sga_ie_elt_addr;	/* import/export element base address */
	short	sga_ie_elt_num;		/* import/export element number */
	short	sga_dt_elt_addr;	/* data transport element base addres */
	short	sga_dt_elt_num;		/* data transport element number */
	short	*sga_trans_elt_av;	/* transport element address vector */
	short	*sga_stor_elt_av;	/* storage element address vector */
	short	*sga_ie_elt_av;		/* import/export address vector */
	short	*sga_dt_elt_av;		/* data transport address vector */
} sgarea_t;

typedef struct sgatype {		/* SGAIOCGET - retrieve device status */
	char	sga_name[64];		/* Name */
	char	sga_vid[25];		/* Vendor id and model (product) id */
	short	sga_type;		/* media changer type */
	int	sga_options;		/* options */
	int	sga_bcs;		/* bar code scanner present */
} sgatype_t;

typedef struct sgatype_request {
	int		sga_size;
	sgatype_t	*sga_tp;
} sgatype_request_t;

#ifdef	__cplusplus
}
#endif

#endif /* _SYS_SGAIO_H */
